package ParsingXMLDoc;

/*
 * Author: Nader Kesserwan,  October 17, 2016
 * This API javax.xml.stream package reads the path scenario expressed as XML document and generates TDL 
 * syntax based on the elements that it encounters in the document. Esterline CMC Electronics
 */
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import javax.xml.stream.XMLInputFactory;
import javax.xml.stream.XMLStreamConstants;
import javax.xml.stream.XMLStreamReader;
import javax.xml.stream.XMLStreamException;
public class Parser {
	                             
	private static String filename = "./src/ParsingXMLDoc/SuccessfulDeployment.xml";  // the xml document to parse 
	private static String Tester = "Tester"; 
	private static String configName="";
	private static String[] componentInstance= {"",""};
	private static boolean isEndTestConfiguration = false;
	private static FileWriter fWriter;
	private static BufferedWriter writer;
	private static String buffer="TDLan Specification myTDLModule { \n";
	private static String TestDescriptionbuffer="";
	private static boolean isComponentComplete = true;

	public static void  main(String[] args){
		 try {
			 fWriter = new FileWriter("./GenerateTDL/TdlSpecification.tdlan2");  // the TDL specification to develop 
		     writer = new BufferedWriter(fWriter); 
		 } 
		 catch (Exception e) { System.out.println("Couldn't create the file " + e);  }		 
		 System.out.println("Parsing the xml document ...");
		 new Parser();
	}	
	public Parser () {
		XMLStreamReader xr=null;		
		try { xr = XMLInputFactory.newInstance().createXMLStreamReader(new FileInputStream(filename)); 	} 
		catch (FileNotFoundException e) { e.printStackTrace(); } 
		catch (XMLStreamException e) { e.printStackTrace();    } 		
		try {
			while (xr.hasNext()) {			
				int eventType = xr.next();
		        switch (eventType) {	    	    
		            case XMLStreamReader.START_DOCUMENT:	
		            	handleStartDocument(xr);
		    	    break;			        
		            case XMLStreamReader.START_ELEMENT:	
		            	handleStartElement(xr);  
		    	    break;		    	    
		            case XMLStreamConstants.END_ELEMENT:
		            	handleEndElement(xr);		            	  
		            break;		            
		            case XMLStreamConstants.END_DOCUMENT:
		            	handleEndDocument(xr);
		            break;
			    } 
			}
		} 
		catch (XMLStreamException e) {e.printStackTrace(); }
	}
	public void handleStartDocument(XMLStreamReader xr){ 
		// handle event when start of the document is encountered
	}
	public void handleStartElement(XMLStreamReader xr){ 	
		String elementName = xr.getLocalName();
		String attribute ="";
// handle TDL package elements {TestConfiguration, TestDescription, AnnotationType, GateType, ...}		
		if (elementName.equalsIgnoreCase("packagedElements")){
		     attribute = xr.getAttributeValue(0);		 
		     if (attribute.equalsIgnoreCase("tdl:TestConfiguration")){
		    	 configName = attribute.substring(4);
			     buffer += ("\tTest Configuration " + configName + " {");
			     isEndTestConfiguration = true;
		     }			 
		     if (attribute.equalsIgnoreCase("tdl:TestDescription")){		    	 
		    	 xr.getAttributeValue(4);
		    	 TestDescriptionbuffer +=("\n\n\tTest Description " + xr.getAttributeValue(1) + " {");
		    	 TestDescriptionbuffer +=("\n\t\tuse configuration : " + configName +"; {");
		     }
		     if (attribute.equalsIgnoreCase("tdl:Action")){		    	 
			     buffer +=("\n\tAction " + xr.getAttributeValue(1) + ": " + "\"" + xr.getAttributeValue(2) + "\"" + ";"
		                                 +" // description to be manually edited");		     
		     } 
		     if (attribute.equalsIgnoreCase("tdl:VerdictType")){		    	 
			     buffer +=("\n\tVerdict " + xr.getAttributeValue(1) + ";");
		     }
		     if (attribute.equalsIgnoreCase("tdl:GateType")){		    	 
		    	 buffer +=("\n\tData Set SendSet { \n\t\t instance INSTANCE; // to be manually edited\n\t}");

		    	 buffer +=("\n\tData Set ResponseSet { \n\t\t instance RESPONSE; // to be manually edited\n\t}");
		    	 
			     buffer +=("\n\tGate Type " + xr.getAttributeValue(1) + " accepts " + "SendSet, ResponseSet" + ";"+
		    	            " // to be manually edited");
			     buffer +=("\n\tComponent Type defaultCompType { gate types: " + xr.getAttributeValue(1) + ";" + "}");
		     }   

		     if (attribute.equalsIgnoreCase("tdl:TimeUnit")){		    	 
			     buffer +=("\n\tTime Unit " + xr.getAttributeValue(1) + ";");
		     }
		     if (attribute.equalsIgnoreCase("tdl:..."))
		     // handle other TDL packages
		    	 ; // ...			     
		}
// handle component instance for test configuration		
		if (elementName.equalsIgnoreCase("componentInstance")){
			 attribute = xr.getAttributeValue(0);
			 buffer +=("\n\t\tinstantiate " + attribute + " as "+ Tester +" of type defaultCompType\n\t\thaving { gate ");
			 Tester = "SUT";
		}
// handle gate instance for test configuration		
		if  (elementName.equalsIgnoreCase("gateInstance")){
			 attribute = xr.getAttributeValue(0); 
			 if (componentInstance[0] == "")
				 componentInstance[0] = attribute;
			 else if (componentInstance[1] == "")
				 componentInstance[1] = attribute;
			 buffer += (attribute + " of type defaultGT ; }\n");
		}
// handle connection for test configuration		
		if  (elementName.equalsIgnoreCase("connection")){
			 buffer +=("\n\t\tconnect "+ componentInstance[0] + " to " + componentInstance[1] +";");
		}
// handle behaviour for test description		
		if  (elementName.equalsIgnoreCase("behaviour")){			
			attribute = xr.getAttributeValue(0);			
			if (attribute != null && attribute.equalsIgnoreCase("tdl:ActionReference")){
				TestDescriptionbuffer += "\n\t\t\tperform action " + xr.getAttributeValue(1) + " on component " ;
			    isComponentComplete = false;
			}
		}
		
		if  (elementName.equalsIgnoreCase("behaviour")){			
			attribute = xr.getAttributeValue(0);			
			if (attribute != null && attribute.equalsIgnoreCase("tdl:Interaction")){
				String str = xr.getAttributeValue(1).substring(5);
				String strArray[] = str.split("to ");
				
				TestDescriptionbuffer += "\n\t\t\t" + "g" + strArray[0] + " sends instance INSTANCE" + " to " + "g" +strArray[1] + ";"
	                                  +  "// INSTANCE to be manually edited";
			}
		}
		
// handle annotation for test description		
		if  (elementName.equalsIgnoreCase("annotation") && !isComponentComplete){
			attribute = xr.getAttributeValue(0);
			if (attribute.equalsIgnoreCase(componentInstance[0] ) )
				TestDescriptionbuffer +=  componentInstance[0].substring(1) + ";";
			else if (attribute.equalsIgnoreCase(componentInstance[1]))
				TestDescriptionbuffer +=  componentInstance[1].substring(1) + ";";
			isComponentComplete = true;
		}
		if (elementName.equalsIgnoreCase("annotation")) {
			attribute = xr.getAttributeValue(0);
			if (attribute != null && attribute.equalsIgnoreCase("RESPONSE")){
				
				TestDescriptionbuffer += "\n\t\t\talternatively\n\t\t\t{"; 
				TestDescriptionbuffer += "\n\t\t\t\t" + componentInstance[1] + " sends instance RESPONSE" + " to " +componentInstance[0] + ";" 
				                      +  "// REPSONSE to be manually edited";
				TestDescriptionbuffer += "\n\t\t\t\tset verdict to PASS;";				
				TestDescriptionbuffer += "\n\t\t\t}";
				TestDescriptionbuffer += "\n\t\t\tor\n\t\t\t{";
				TestDescriptionbuffer += "\n\t\t\t\tgate " + componentInstance[1] + " is quiet for (7.0 SECOND);" ;
				TestDescriptionbuffer += "\n\t\t\t\tset verdict to FAIL;";
				TestDescriptionbuffer += "\n\t\t\t}";
			}
		}
	} // end handleStartElement method
	
	public void handleEndElement(XMLStreamReader xr){
		String elementName = xr.getLocalName();
		 if (elementName.equalsIgnoreCase("packagedElements") && isEndTestConfiguration){
			 buffer +=("\n\t}");
			 isEndTestConfiguration = false;
		 }	
	}
	public void handleEndDocument(XMLStreamReader xr){ 
		// handle event when end of the document is encountered
		buffer += TestDescriptionbuffer;
		buffer += "\n\t\t} \n\t} \n}";
		writeModuleData(buffer); 
		try { writer.close(); } 
		catch (IOException e) {System.out.println("Couldn't close the file " + e);}
		System.out.println("<TDLSpecification.tdlan2> file is generated");
	}
	public void writeModuleData(String moduleData){
		try { writer.write(moduleData); } 
		catch (Exception e) {System.out.println("Couldn't write to the file " + e.getMessage()); }		 
	}
}